#
# spec file for package apache2-mod_perl (Version 1.99_08)
#
# Copyright (c) 2003 SuSE Linux AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  apache2-devel-packages perl-HTML-Parser perl-Tie-IxHash perl-URI perl-libwww-perl
# usedforbuild    aaa_base acl attr bash bind9-utils bison coreutils cpio cpp cvs cyrus-sasl2 db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libstdc++ libxcrypt m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam pam-devel pam-modules patch permissions ps rcs readline sed sendmail shadow strace syslogd sysvinit tar texinfo timezone unzip util-linux vim zlib zlib-devel apache2 apache2-devel apache2-prefork autoconf automake binutils bzip2 cracklib expat gcc gdbm gettext libapr0 libtool openssl perl perl-HTML-Parser perl-Tie-IxHash perl-URI perl-libwww-perl rpm

Name:         apache2-mod_perl
%define apxs apxs2
%define apache apache2
%define apache_libexecdir %(%{apxs} -q LIBEXECDIR)
%define apache_sysconfdir %(%{apxs} -q SYSCONFDIR)
%define apache_includedir %(%{apxs} -q INCLUDEDIR)
%define apache_serverroot %(%{apxs} -q PREFIX)
%define version_perl      %(rpm -q --queryformat '%%{version}' perl)
%define apache_mmn        %(MMN=$(%{apxs} -q LIBEXECDIR)_MMN; test -x $MMN && $MMN)
Summary:      Embedded Perl for Apache
Group:        Productivity/Networking/Web/Servers
Autoreqprov:  on
License:      Other License(s), see package
Requires:     apache2, perl = %{version_perl} %{apache_mmn}
Requires:     perl-HTML-Parser perl-Tie-IxHash 
Requires:     perl-URI perl-libwww-perl
Conflicts:    mod_perl
Autoreqprov:  on
Version:      1.99_08
Release:      63
Source0:      mod_perl-%{version}.tar.bz2
URL:          http://perl.apache.org/
Icon:         mod_perl.xpm
BuildRoot:    %{_tmppath}/%{name}-%{version}-build

%description
The Apache/Perl integration project brings together the full power of
the Perl programming language and the Apache HTTP server.


With mod_perl it is possible to write Apache modules entirely in
Perl. In addition, the persistent interpreter embedded in the server
avoids the overhead of starting an external interpreter and the
penalty of Perl start-up time.

%prep
%setup -q -n mod_perl-%{version}
/usr/share/apache2/get_module_list

%build
eval `perl -V:installarchlib`
if [ -e $installarchlib/perllocal.pod ]; then
    mv $installarchlib/perllocal.pod $installarchlib/perllocal.pod.bak ;
fi
perl Makefile.PL MP_APXS=`which %{apxs}` MP_CCOPTS="$RPM_OPT_FLAGS -fPIC" 
ln -s Apache-mod_perl_guide-1.29/bin bin
make OPTIMIZE=
# XXX perlio.t needs the permissions or it fails
mkdir -p t/htdocs/perlio; chmod 777 t/htdocs/perlio 
# XXX mod_include/SSI does not include files when they are not named .shtml
mv t/htdocs/includes-registry/test.pl t/htdocs/includes-registry/test.shtml
mv t/htdocs/includes-registry/cgipm.pl t/htdocs/includes-registry/cgipm.shtml
sed 's/\.pl/.shtml/' t/htdocs/includes/test.shtml > tmpfile && mv tmpfile t/htdocs/includes/test.shtml
make test

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/%{perl_archlib}
install -d $RPM_BUILD_ROOT/%{apache_libexecdir}
install -d $RPM_BUILD_ROOT/%{apache_includedir}/modules/perl
install -d $RPM_BUILD_ROOT/var/adm/perl-modules
install -d $RPM_BUILD_ROOT/%{apache_sysconfdir}/conf.d
make PREFIX=$RPM_BUILD_ROOT/usr \
     INSTALLMAN1DIR=$RPM_BUILD_ROOT/%{_mandir}/man1 \
     INSTALLMAN3DIR=$RPM_BUILD_ROOT/%{_mandir}/man3 \
     MODPERL_AP_LIBEXECDIR=$RPM_BUILD_ROOT/%{apache_libexecdir} \
     install
strip $RPM_BUILD_ROOT/%{apache_libexecdir}/mod_perl.so
cp src/modules/perl/*.h $RPM_BUILD_ROOT/%{apache_includedir}/modules/perl/
eval `perl -V:installarchlib`
mv $RPM_BUILD_ROOT/$installarchlib/perllocal.pod \
    $RPM_BUILD_ROOT/var/adm/perl-modules/mod_perl
mv $installarchlib/perllocal.pod.bak $installarchlib/perllocal.pod
cat > $RPM_BUILD_ROOT/%{apache_sysconfdir}/mod_perl-startup.pl <<-EOF
	
	\$ENV{GATEWAY_INTERFACE} =~ /^CGI-Perl/ or die "GATEWAY_INTERFACE not Perl!";
	
	use Apache2 ();
	
	use lib qw(/srv/www/perl-lib);
	
	# enable if the mod_perl 1.0 compatibility is needed
	# use Apache::compat ();
	
	use ModPerl::Util (); #for CORE::GLOBAL::exit
	
	use Apache::RequestRec ();
	use Apache::RequestIO ();
	use Apache::RequestUtil ();
	
	use Apache::Server ();
	use Apache::ServerUtil ();
	use Apache::Connection ();
	use Apache::Log ();
	
	use APR::Table ();
	
	use ModPerl::Registry ();
	
	use Apache::Const -compile => ':common';
	use APR::Const -compile => ':common';
	
	1;
EOF
mkdir -p $RPM_BUILD_ROOT/%{apache_serverroot}/perl-lib
cat > $RPM_BUILD_ROOT/%{apache_sysconfdir}/conf.d/mod_perl.conf <<EOF
<Directory "%{apache_serverroot}/perl-lib">
    AllowOverride None
    Options None
    Order allow,deny
    Deny from all
</Directory>
 
<IfModule mod_perl.c>
    PerlRequire "/etc/apache2/mod_perl-startup.pl"
    
    ScriptAlias /perl/ "%{apache_serverroot}/cgi-bin/"
    <Location /perl/>
	# mod_perl mode
	SetHandler perl-script
	PerlResponseHandler ModPerl::Registry
	PerlOptions +ParseHeaders
	Options +ExecCGI
    </Location>
    
    ScriptAlias /cgi-perl/ "%{apache_serverroot}/cgi-bin/"
    <Location /cgi-perl>
	# perl cgi mode
	SetHandler  perl-script
	PerlResponseHandler ModPerl::PerlRun
	PerlOptions +ParseHeaders
	Options +ExecCGI
    </Location>
    
    # The /cgi-bin/ ScriptAlias is already set up in httpd.conf
    
</IfModule>
 
# vim: ft=apache
EOF

%files
%defattr(-,root,root)
%doc STATUS LICENSE README MANIFEST INSTAL* Changes 
%dir %{apache_libexecdir}
%{apache_libexecdir}/mod_perl.so
/var/adm/perl-modules/mod_perl
%{apache_includedir}/modules/perl/
%config(noreplace) %{apache_sysconfdir}/mod_perl-startup.pl
%config(noreplace) %{apache_sysconfdir}/conf.d/mod_perl.conf
%dir %{apache_serverroot}/perl-lib
%{_mandir}/man3/*
%{perl_sitearch}/Apache
%{perl_sitearch}/Apache2
%{perl_sitearch}/Apache2.pm
%{perl_sitearch}/APR
%{perl_sitearch}/APR.pm
%dir %{perl_sitearch}/Bundle
%{perl_sitearch}/Bundle/ApacheTest.pm
%{perl_sitearch}/ModPerl
#%dir %{perl_sitearch}/auto
%{perl_sitearch}/auto/APR
%{perl_sitearch}/auto/Apache
%{perl_sitearch}/auto/ModPerl
%{perl_sitearch}/auto/mod_perl
%{perl_sitearch}/mod_perl.pm

%clean
find $RPM_BUILD_ROOT | sed "s#$RPM_BUILD_ROOT##" | sort > %{_tmppath}/install_file.$$.txt
rpm -qpl %{_rpmdir}/%{_target_cpu}/*-%{version}-%{release}.%{_target_cpu}.rpm | sort > %{_tmppath}/rpm_file.$$.txt
(diff -u %{_tmppath}/install_file.$$.txt %{_tmppath}/rpm_file.$$.txt)
rm -f  %{_tmppath}/install_file.$$.txt %{_tmppath}/rpm_file.$$.txt

%changelog -n apache2-mod_perl
* Fri Feb 28 2003 - poeml@suse.de
- make the test suite pass again, by renaming two .pl files of the
  test suite to .shtml, because mod_include didn't include files
  other than .shtml any longer
* Wed Feb 12 2003 - poeml@suse.de
- rename package from mod_perl_2 to apache2-mod_perl
* Tue Feb 11 2003 - poeml@suse.de
- call the new apache configuration script, so modules that are
  needed for the test get loaded
* Mon Feb 10 2003 - poeml@suse.de
- MPM specific links to mod_dav_svn.so are no longer needed
- add apache_libexecdir to filelist
* Tue Jan 14 2003 - poeml@suse.de
- update to 1.99_08
- <Perl> directive missing closing '>' bug fixed, and much else
- drop /etc/apache2/modules/mod_perl
- add /etc/apache2/mod_perl-startup.pl, setting up with
  /srv/www/perl-lib in @INC
- add /etc/apache2/conf.d/mod_perl.conf, setting up scriptaliases
  /perl/, and /cgi-perl/ (for unaltered CGI scripts under mod_perl)
- use %%defattr
* Wed Dec 04 2002 - poeml@suse.de
- update to 1.99_07
- build one module, it works for all MPMs
- use RPM_OPT_FLAGS
* Fri Aug 30 2002 - poeml@suse.de
- new package with mod_perl-1.99_05 for Apache 2
